SystemOrganization addCategory: #'Smallchange-Core'!
SystemOrganization addCategory: #'Smallchange-Core-Commands'!

!Number methodsFor: '*smallchange-core' stamp: 'StuartHerring 12/11/2011 11:28'!
printAsCurrency
	| s|
	s := WriteStream with: ''.
	self printOn: s showingDecimalPlaces: 2.
	^s contents! !

MbObject subclass: #ScObject
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScObject class methodsFor: 'instance creation' stamp: 'StuartHerring 12/11/2011 14:19'!
profile: aProfile
	^self basicNew
		initializeWithProfile: aProfile;
		yourself.! !

!ScObject methodsFor: 'initialization' stamp: 'StuartHerring 12/11/2011 14:20'!
initializeWithProfile: aProfile
	self initialize.
	profile := aProfile! !

ScObject subclass: #ScTransaction
	instanceVariableNames: 'comment amount date pool account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:20'!
account
	<valueSelector: #accountList>
	<required>
	^account! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
account: anAccount
	self set: #account to: anAccount! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/29/2012 10:43'!
accountList
	^profile accounts! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
amount
	<required>
	<currency: $$>
	^amount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:02'!
amount: anAmount
	self set: #amount to: anAmount! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 15:06'!
comment
	^comment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
comment: aComment
	self set: #comment to: aComment! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 2/6/2012 21:54'!
date
	<date>
	^date! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
date: aDateAndTime
	self set: #date to: aDateAndTime! !

!ScTransaction methodsFor: 'initialization' stamp: 'StuartHerring 2/6/2012 21:47'!
initialize
	super initialize.
	date := Date today.! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/30/2012 18:31'!
pool
	<valueSelector: #poolList>
	^pool! !

!ScTransaction methodsFor: 'accessing' stamp: 'StuartHerring 1/12/2012 17:05'!
pool: aPool
	self set: #pool to: aPool! !

!ScTransaction methodsFor: 'constraints' stamp: 'StuartHerring 1/30/2012 18:31'!
poolList
	^profile pools! !

ScTransaction subclass: #ScTransferSource
	instanceVariableNames: 'transfer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScTransaction subclass: #ScTransferTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScObject subclass: #ScTransactionHolder
	instanceVariableNames: 'name transactions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

ScTransactionHolder subclass: #ScAccount
	instanceVariableNames: 'openingBalance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScAccount methodsFor: 'initialization' stamp: 'StuartHerring 1/18/2012 21:02'!
initialize
	super initialize.
	openingBalance := 0.! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:56'!
openingBalance
	<label: 'Opening Balance'>
	<currency: $$>
	<required>
	^openingBalance! !

!ScAccount methodsFor: 'accessing' stamp: 'StuartHerring 1/18/2012 20:55'!
openingBalance: anAmount
	openingBalance := anAmount.! !

ScTransactionHolder subclass: #ScPool
	instanceVariableNames: 'defaultAccount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScPool methodsFor: 'initialization' stamp: 'StuartHerring 2/7/2012 21:47'!
accountList
	^profile accounts! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:50'!
defaultAccount
	<required>
	<valueSelector: #accountList>
	^defaultAccount! !

!ScPool methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:48'!
defaultAccount: anAccount
	self set: #defaultAccount to: anAccount! !

!ScTransactionHolder methodsFor: 'actions' stamp: 'StuartHerring 2/7/2012 21:45'!
addTransaction: aTransaction
	transactions add: aTransaction! !

!ScTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:45'!
asString
	^name! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:57'!
balance
	<ignore>
	^transactions inject: self openingBalance into: [ :total :this | total + this amount ]! !

!ScTransactionHolder methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:55'!
initialize
	super initialize.
	transactions := OrderedCollection new.! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:45'!
name
	<label: 'Name'>
	<required>
	^name! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/7/2012 21:46'!
name: aName
	name := aName! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:57'!
openingBalance
	<ignore>
	^0! !

!ScTransactionHolder methodsFor: 'actions' stamp: 'StuartHerring 2/7/2012 21:46'!
removeTransaction: aTransaction
	transactions remove: aTransaction! !

!ScTransactionHolder methodsFor: 'accessing' stamp: 'StuartHerring 2/12/2012 19:39'!
transactions
	<ignore>
	^transactions! !

ScObject subclass: #ScTransfer
	instanceVariableNames: 'source destination amount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScTransfer methodsFor: 'initialization' stamp: 'StuartHerring 1/7/2012 13:05'!
initialize
	super initialize.
	source := ScTransferSource for: self.
	destination := ScTransferTransaction for: self.! !

MbCommand subclass: #ScModelCommand
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

ScModelCommand subclass: #ScAddAccount
	instanceVariableNames: 'account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddAccount class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:30'!
profile: aProfile account: anAccount
	^self new
		profile: aProfile;
		account: anAccount;
		yourself.! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:29'!
account: anAccount
	account := anAccount! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:30'!
do
	profile addAccount: account! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:33'!
printOn: aStream
	aStream nextPutAll: 'Added account named ';
		nextPutAll: account name.! !

!ScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:31'!
undo
	profile removeAccount: account! !

ScModelCommand subclass: #ScAddPool
	instanceVariableNames: 'pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScAddPool class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:31'!
profile: aProfile pool: aPool
	^self new
		profile: aProfile;
		pool: aPool;
		yourself.! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
do
	profile addPool: pool! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
pool: aPool
	pool := aPool! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:33'!
printOn: aStream
	aStream nextPutAll: 'Added pool named ';
		nextPutAll: pool name.! !

!ScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:32'!
undo
	profile removePool: pool! !

!ScModelCommand methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:28'!
profile: aProfile
	profile := aProfile! !

ScModelCommand subclass: #ScRecordTransaction
	instanceVariableNames: 'transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core-Commands'!

!ScRecordTransaction class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:29'!
profile: aProfile transaction: aTransaction
	^self new
		profile: aProfile; transaction: aTransaction;
		yourself! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:56'!
do
	profile addTransaction: transaction.
	transaction account addTransaction: transaction.
	transaction pool ifNotNil: [ :p | p addTransaction: transaction]! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:54'!
printOn: aStream
	aStream nextPutAll: 'Spent $';
		nextPutAll: transaction amount printAsCurrency;
		nextPutAll: ' on ';
		nextPutAll: (transaction pool ifNil: [ 'Unallocated' ] ifNotNil: [ :p | p name ]);
		nextPutAll: ' from ';
		nextPutAll: transaction account name.! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:28'!
transaction: aTransaction
	transaction := aTransaction.! !

!ScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:59'!
undo
	transaction account removeTransaction: transaction.
	profile removeTransaction: transaction.
	transaction pool ifNotNil: [ :p | p removeTransaction: transaction ]! !

Object subclass: #ScProfile
	instanceVariableNames: 'name pools accounts recurringTransactions transactions primaryIncome'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Core'!

!ScProfile class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/5/2012 17:26'!
name: aName
	^self basicNew
		initializeWithName: aName;
		yourself.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:14'!
accounts
	^accounts! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:20'!
addAccount: anAccount
	(accounts anySatisfy: [ :p | p name = anAccount name]) 
		ifTrue: [ MbValidationError signal: 'An account with the name ', anAccount name, ' already exists' ].
	accounts add: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/18/2012 21:19'!
addPool: aPool
	(pools anySatisfy: [ :p | p name = aPool name]) 
		ifTrue: [ MbValidationError signal: 'A pool with the name ', aPool name, ' already exists' ].
	pools add: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 12/11/2011 15:45'!
addTransaction: aTransaction
	transactions add: aTransaction! !

!ScProfile methodsFor: 'initialization' stamp: 'StuartHerring 12/8/2011 18:02'!
initializeWithName: aName
	self initialize.
	name := aName.
	pools := OrderedCollection new.
	accounts := OrderedCollection new.
	recurringTransactions := OrderedCollection new.
	transactions := OrderedCollection new.
	primaryIncome := nil.! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/8/2011 18:07'!
name
	^name! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newAccount
	^ScAccount profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newPool
	^ScPool profile: self! !

!ScProfile methodsFor: 'instance creation' stamp: 'StuartHerring 1/30/2012 18:33'!
newTransaction
	^ScTransaction profile: self! !

!ScProfile methodsFor: 'accessing' stamp: 'StuartHerring 12/11/2011 10:52'!
pools
	^pools! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:19'!
removeAccount: anAccount
	accounts remove: anAccount! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 1/22/2012 14:20'!
removePool: aPool
	pools remove: aPool! !

!ScProfile methodsFor: 'actions' stamp: 'StuartHerring 2/1/2012 20:57'!
removeTransaction: aTransaction
	transactions remove: aTransaction! !
